function returnPromise(word) {
	return Promise.resolve(word);
}

// async＋関数のパターン
async function func() {
	let value = await returnPromise("func");
	return value;
}

// async＋メソッドのパターン
class Sample {
	async method() {
		let value = await returnPromise("method");
		return value;
	}
}

// async＋アロー関数のパターン
let arrow = async () => {
	let value = await returnPromise("arrow");
	return value;
};

// 実行例
let p1 = func();
let p2 = new Sample().method();
let p3 = arrow();

Promise.all([p1, p2, p3])
	.then(values => {
		console.log(values); // [ 'func', 'method', 'arrow' ] と表示される
	});
