let worker = new Worker("task.js");

// 今までの書き方 → let typedArray = new Uint8Array(new ArrayBuffer(8));
let typedArray = new Uint8Array(new SharedArrayBuffer(8));
for (let i = 0; i < typedArray.length; ++i) {
	typedArray[i] = Math.pow(2, i);
}

// 準備した内容の確認
console.log(`toString(): ${typedArray.toString()}`); // toString(): 1,2,4,8,16,32,64,128
console.log(`byteLength: ${typedArray.byteLength}`); // byteLength: 8

// 第1引数が送るオブジェクト、第2引数がtransferする対象の指定
worker.postMessage(typedArray, [typedArray.buffer]);

// shareされていて値の変更も参照もできる！
typedArray[2] = 10;               // WebWorker側にも反映される！
Atomics.store(typedArray, 3, 20); // Atomicに操作するAPIが用意された

console.log(`toString(): ${typedArray.toString()}`); // toString(): 1,2,10,20,16,32,64,128
console.log(`byteLength: ${typedArray.byteLength}`); // byteLength: 8
